package cz.vsb.gisak.kuc273;

/****************************************************************/ 
/*                      ImageEnhancementDialog	                            */ 
/*                                                              */ 
/****************************************************************/ 
import java.awt.*;
import java.awt.event.*; 

import javax.imageio.ImageIO;
import javax.swing.*; 

import java.awt.image.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FilenameFilter;
import java.io.IOException;

//import sun.awt.image.ToolkitImage;
import java.util.List;
import cz.vsb.gisak.StyleImage; 
import com.vividsolutions.jump.workbench.model.*;
import com.vividsolutions.jump.workbench.plugin.PlugInContext;
import javax.swing.event.*; 
import javax.swing.filechooser.FileFilter;
import javax.swing.table.*;
/** 
 * Summary description for ImageEnhancementDialog 
 * 
 */ 
public class ImageEnhancementDialog extends JDialog
{ 
	//***** Variables declaration *****
	
	private PlugInContext context;
	//trida z baliku cz.vsb.gisak - pouziva se pro vykreslen obrazu	
	private StyleImage ims=null;
	//pro pouziti konvolucnich filtru na rastr je treba pracovat s objektem tridy BufferedImage 
	private BufferedImage src;
	//retezec, jenz se pouziva pro urceni druhu filtru
	private String filter="cz.vsb.gisak.kuc273.Averaging";
	private Image image;
	//**********************************
	
	//***** GUI Components *****
	
	private JTabbedPane jTabbedPane4; 
	private JPanel contentPane; 
	//----- 
	private JButton jOk;
	private JButton jRestore;
	private JButton jSaveAs;
	private JButton jCancle; 
	private JPanel jMenu;
	//----- 
	private JRadioButton jGaussianBlur; 
	private JRadioButton jAvaraging;
	private JRadioButton jSharpening; 
	private JRadioButton jEdgeDetection; 
	private JRadioButton jReverseLookUp; 
	private JRadioButton jEmboss; 
	private JPanel jPanelDefinedFilters; 
	//----- 
	private JRadioButton jK3; 
	private JRadioButton jK5; 
	private JRadioButton jK7;
	
	private JTable jTable1; 
	private JScrollPane jSP; 
	private JPanel jPanelKernel; 
	private JPanel jKern; 
	//----- 
	private ButtonGroup btnGroup2; 
	private ButtonGroup btnGroup1; 
	// ************************************
 
 
	public ImageEnhancementDialog  (PlugInContext context)
	{
		//inicializace pluginu
		super(context.getWorkbenchFrame());
		initializeComponent();
		this.context = context;

		//deklarace pole vrstev a ulozeni vybranch vrstev do tohoto pole
		Layer[] layers;
		layers = context.getSelectedLayers();
		
		//ziskani image, jez "maji styl" StyleImage z baliku cz.vsb.gisak
		for (int j=0;j<layers.length;j++){
			List styles = layers[j].getStyles();
			for (int i=0;i<styles.size();i++){
				String styleinfo = styles.get(i).toString();
				//porovnani, zda-li je aktualni styl odpovida StyleImage
				if (styleinfo.equals("cz.vsb.gisak.StyleImage")) {
					ims = (StyleImage)styles.get(i);
//					//ulozeni obrazu na pozici j z vybranych vrstev do promenne image
					image = (Image)ims.getImage();
					this.setTitle("Image Enhancement (" +layers[j].getName()+ ") ");
				}
			}
		}
		
		//osetreni, zda-li byl vybran nejaky obrazek
		//pokud ano, je preveden na BufferedImage - metoda toBufferedImage je uvedena nize
		if (image == null) {
			//pouziti metody dialog pro zobrazeni dial. okna - viz nize
			dialog("It's not selected any Image layer! Use Layer/Add New Image Layer.");
			this.dispose();
		} else {
			src = this.toBufferedImage(image);
			this.setVisible(true);
		}
	} 
 
	/** 
	 * This method is called from within the constructor to initialize the form. 
	 * WARNING: Do NOT modify this code. The content of this method is always regenerated 
	 * by the Windows Form Designer. Otherwise, retrieving design might not work properly. 
	 * Tip: If you must revise this method, please backup this GUI file for JFrameBuilder 
	 * to retrieve your design properly in future, before revising this method. 
	 */ 
	private void initializeComponent() 
	{ 
		
		//inicializace GUI
		jTabbedPane4 = new JTabbedPane(); 
		contentPane = (JPanel)this.getContentPane(); 
		//----- 
		jOk = new JButton(); 
		jRestore = new JButton(); 
		jSaveAs = new JButton(); 
		jCancle = new JButton(); 
		jMenu = new JPanel(); 
		//----- 
		jGaussianBlur = new JRadioButton(); 
		jAvaraging = new JRadioButton(); 
		jPanelDefinedFilters = new JPanel(); 
		jSharpening = new JRadioButton(); 
		jEdgeDetection = new JRadioButton(); 
		jReverseLookUp	= new JRadioButton();
		jEmboss = new JRadioButton();
		//----- 
		jK3 = new JRadioButton(); 
		jK5 = new JRadioButton(); 
		jK7 = new JRadioButton(); 
		
		jTable1 = new JTable(); 
		jSP = new JScrollPane(); 
		jPanelKernel = new JPanel(); 
		jKern = new JPanel();
		//----- 
		btnGroup2 = new ButtonGroup(); 
		btnGroup1 = new ButtonGroup(); 
 
		// 
		
		jTabbedPane4.addTab("Predefined filter", jPanelDefinedFilters); 
		jTabbedPane4.addTab("Userdefined filter", jPanelKernel); 
		jTabbedPane4.addChangeListener(new ChangeListener() { 
			public void stateChanged(ChangeEvent e) 
			{ 
				jTabbedPane4_stateChanged(e); 
			} 
 
		}); 
		
		// 
		// contentPane 
		// 
		contentPane.setLayout(new BorderLayout(0, 0)); 
		contentPane.add(jMenu, BorderLayout.SOUTH); 
		contentPane.add(jTabbedPane4, BorderLayout.CENTER); 
		// 
		// jOk 
		// 
		jOk.setText("OK"); 
		jOk.addActionListener(new ActionListener() { 
			public void actionPerformed(ActionEvent e) 
			{ 
				jOk_actionPerformed(e); 
			} 
 
		}); 
		
		// 
		// jRestore 
		// 
		jRestore.setText("Restore"); 
		jRestore.addActionListener(new ActionListener() { 
			public void actionPerformed(ActionEvent e) 
			{ 
				jRestore_actionPerformed(e); 
			} 
 
		}); 
		
		// 
		// jSaveAs 
		// 
		jSaveAs.setText("Save"); 
		jSaveAs.addActionListener(new ActionListener() { 
			public void actionPerformed(ActionEvent e) 
			{ 
				jSaveAs_actionPerformed(e); 
			} 
 
		}); 
		
		// 
		// jCancle 
		// 
		jCancle.setText("Cancel"); 
		jCancle.addActionListener(new ActionListener() { 
			public void actionPerformed(ActionEvent e) 
			{ 
				jCancle_actionPerformed(e); 
			} 
 
		}); 
		
		// 
		// jMenu 
		// 
		jMenu.setLayout(new GridLayout(1, 0, 0, 0)); 
		jMenu.add(jOk, 0);
		jMenu.add(jRestore, 1);
		jMenu.add(jSaveAs, 2);
		jMenu.add(jCancle, 3);
		
		
		// 
		// jGaussianBlur 
		// 
		jGaussianBlur.setText("Gaussian Blur"); 
		jGaussianBlur.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jGaussianBlur_itemStateChanged(e); 
			} 
 
		}); 
		
		// 
		// jAvaraging 
		// 
		jAvaraging.setText("Averaging"); 
		jAvaraging.setSelected(true); 
		jAvaraging.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jAvaraging_itemStateChanged(e); 
			} 
 
		});
		
		// 
		// jSharpening 
		// 
		jSharpening.setText("Sharpening"); 
		jSharpening.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jSharpening_itemStateChanged(e); 
			} 
		}); 
		
		// 
		// jEdgeDetection 
		// 
		jEdgeDetection.setText("Edge Detection"); 
		jEdgeDetection.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jEdgeDetection_itemStateChanged(e); 
			} 
 
		}); 
		
		// 
		// jReverseLookUp 
		// 
		jReverseLookUp.setText("Reverse LookUp"); 
		jReverseLookUp.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jReverseLookUp_itemStateChanged(e); 
			} 
 
		}); 
		
		// 
		// jEmboss 
		// 
		jEmboss.setText("Emboss"); 
		jEmboss.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jEmboss_itemStateChanged(e); 
			} 
 
		}); 
		
		// 
		// jPanelDefinedFilters 
		// 
		jPanelDefinedFilters.setLayout(new GridLayout(3, 2, 5, 5)); 
		jPanelDefinedFilters.add(jAvaraging, 0); 
		jPanelDefinedFilters.add(jGaussianBlur, 1);
		jPanelDefinedFilters.add(jSharpening, 2); 
		jPanelDefinedFilters.add(jEdgeDetection, 3); 
		jPanelDefinedFilters.add(jReverseLookUp, 4); 
		jPanelDefinedFilters.add(jEmboss, 5); 
		
		
		
		// 
		// jK5 
		// 
		jK5.setText("5x5"); 
		jK5.setSelected(false); 
		jK5.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jK5_itemStateChanged(e);
				setTable(5);}
 
		}); 
		
		// 
		// jK7 
		// 
		jK7.setText("7x7"); 
		jK7.setSelected(false); 
		jK7.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jK7_itemStateChanged(e);
				setTable(7);
				
				
			} 
 
		}); 
//		 
		// jK3 
		// 
		jK3.setText("3x3"); 
		jK3.setSelected(true); 
		jK3.addItemListener(new ItemListener() { 
			public void itemStateChanged(ItemEvent e) 
			{ 
				jK3_itemStateChanged(e);
				setTable(3);
			} 
 
		}); 
		
		// 
		// jTable1 
		//
		/*TableModel dataModel = new AbstractTableModel(){
			
		};*/
		jTable1.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS); 
		jTable1.setModel(new DefaultTableModel(3, 3));
		for (int h=0; h <3; h++){			
			for (int g=0; g<3; g++){
				jTable1.setValueAt(0,g,h);
			}
		}
		// 
		
		
 		// 
 		// jKern 
 		// 
 		jKern.setLayout(new FlowLayout(FlowLayout.CENTER, 30, 5)); 
 		jKern.add(jK3, 0);
 		jKern.add(jK5, 1);
 		jKern.add(jK7, 2);
 		 
		
 		// 	 jSP 
		// 
		jSP.setViewportView(jTable1); 
		
		//		 btnGroup2 
		// 
		btnGroup2.add(jK3); 
		btnGroup2.add(jK5); 		
		btnGroup2.add(jK7); 
		// 
		// 
		// jPanelKernel 
		// 
		jPanelKernel.setLayout(new BorderLayout(0, 0)); 
		jPanelKernel.add(jKern, BorderLayout.NORTH);
		jPanelKernel.add(jSP, BorderLayout.CENTER);
		// 
		
		// btnGroup1 
		// 
		btnGroup1.add(jAvaraging);
		btnGroup1.add(jGaussianBlur); 
		btnGroup1.add(jSharpening); 
		btnGroup1.add(jEdgeDetection); 
		btnGroup1.add(jReverseLookUp); 
		btnGroup1.add(jEmboss); 

		// 
		// ImageEnhancementDialog 
		// 
		this.setTitle("Image Enhancement"); 
		this.setLocation(new Point(0, 0)); 
		this.setSize(new Dimension(309, 268)); 
	} 
 
	
	
	// 
	// TODO: Add any appropriate code in the following Event Handling Methods 
	// 
	private void jTabbedPane4_stateChanged(ChangeEvent e) 
	{ 
		System.out.println("\njTabbedPane4_stateChanged(ChangeEvent e) called."); 
		// TODO: Add any handling code here 
 
	} 
 
	private void jRestore_actionPerformed(ActionEvent e) 
	{ 
		//nastaveni obrazku pro zobrazeni puvodniho obrazku
		ims.setImage((Image)image);
		//zobrazeni puvodniho obrazku
		src=this.toBufferedImage(image);
		//prekresleni zobrazeni obrazku
		context.getLayerViewPanel().repaint();
	} 
	
	private void jSaveAs_actionPerformed(ActionEvent e) 
	{ 
		//viz metoda nize
		this.saveImage(src);
	} 
	
	
	private void jCancle_actionPerformed(ActionEvent e) 
	{ 
		//zobrazeni puvodniho obrazku
		ims.setImage((Image)image);
		//prekresleni zobrazeni obrazku
		context.getLayerViewPanel().repaint();
		//ukonceni okna
		this.dispose();
	} 

 
	private void jGaussianBlur_itemStateChanged(ItemEvent e) 
	{ 
		//jestli byl vybran filtr GaussianBlur, do retezce filter se ulozi nazev prislusne tridy
		if(e.getStateChange() == ItemEvent.SELECTED){
			filter="cz.vsb.gisak.kuc273.GaussianBlur";
		}
	} 
 
	private void jAvaraging_itemStateChanged(ItemEvent e) 
	{ 
		if(e.getStateChange() == ItemEvent.SELECTED){
			filter="cz.vsb.gisak.kuc273.Averaging";
		}
	} 
	
	
	private void jSharpening_itemStateChanged(ItemEvent e) 
	{ 
		if(e.getStateChange() == ItemEvent.SELECTED){
			filter="cz.vsb.gisak.kuc273.Sharpening";
		}
	} 
	
	private void jEdgeDetection_itemStateChanged(ItemEvent e) 
	{ 
		if(e.getStateChange() == ItemEvent.SELECTED){
			filter="cz.vsb.gisak.kuc273.EdgeDetection";
		}
	} 
	
	private void jReverseLookUp_itemStateChanged(ItemEvent e) 
	{ 
		if(e.getStateChange() == ItemEvent.SELECTED){
			filter="cz.vsb.gisak.kuc273.ReverseLookUp";
		}
	} 
	
	private void jEmboss_itemStateChanged(ItemEvent e) 
	{ 
		if(e.getStateChange() == ItemEvent.SELECTED){
			filter="cz.vsb.gisak.kuc273.Emboss";
		}
	} 
 
	private void jK3_itemStateChanged(ItemEvent e) 
	{ 
		setTable(3);
		/*System.out.println("\njK3_itemStateChanged(ItemEvent e) called."); 
		System.out.println(">>" + ((e.getStateChange() == ItemEvent.SELECTED) ? "selected":"unselected"));*/ 
		// TODO: Add any handling code here 
		 
	} 
	
	private void jK5_itemStateChanged(ItemEvent e) 
	{ 
		setTable(5);
		System.out.println("\njK3_itemStateChanged(ItemEvent e) called."); 
		System.out.println(">>" + ((e.getStateChange() == ItemEvent.SELECTED) ? "selected":"unselected")); 
		// TODO: Add any handling code here 
		 
	} 
	
	private void jK7_itemStateChanged(ItemEvent e) 
	{ 
		setTable(7);
		System.out.println("\njK3_itemStateChanged(ItemEvent e) called."); 
		System.out.println(">>" + ((e.getStateChange() == ItemEvent.SELECTED) ? "selected":"unselected")); 
		// TODO: Add any handling code here 
		 
	} 
	
	//************************************************************
	
//prevod obrazku na BufferedImage
    public static BufferedImage toBufferedImage(Image image) {
        if (image instanceof BufferedImage) {
            return (BufferedImage)image;
        }
    
        // zajisteni nacteni vsech pixelu v obraze
        image = new ImageIcon(image).getImage();
    
 
        //vytvoreni buffered image
        BufferedImage bimage = null;
        int type = BufferedImage.TYPE_INT_RGB;
        bimage = new BufferedImage(image.getWidth(null), image.getHeight(null), type);
    
        // kopirovani obrazu do buffered image
        Graphics g = bimage.createGraphics();
    
        // kresleni obrazu
        g.drawImage(image, 0, 0, null);
        g.dispose();
    
        return bimage;
    }
    
    public static void dialog( String text )
    {
        //zobrazeni dialogoveho okna s vyobrazenim pozadovaneho textu
    	int dlg = JOptionPane.showConfirmDialog(null, text, "Exception",
            JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
        if( (dlg == JOptionPane.CLOSED_OPTION) )
            System.exit(0);
    }
    
    
	
	private void jOk_actionPerformed(ActionEvent e)
	{
		if(jPanelDefinedFilters.isShowing()){
			//DemoImgOp je rozhrani, jez ma jedinou metodu filter  
			DemoImgOp dio = null;
			try {
				//tim se vytvori instance tridy, ktera je urcena retezcem filter
				
				dio = (DemoImgOp)Class.forName(filter).newInstance();    
			} catch (Exception e2){
				this.dialog("Filter does not work properly!");
			}
			//do promenne buf se ulozi vysledek filtrovani obrazku z promenne src
			BufferedImage buf = dio.filter(src);
			src = buf;
			
			//zobrazeni obrazku
			ims.setImage((Image)src); 
			context.getLayerViewPanel().repaint();
		} else {
			//zjisteni rozmeru uzivatelsky zadane matice
			int count=jTable1.getRowCount();
			float matrix[]=new float[count*count];
			//ulozeni zadanych koeficientu do pole matrix jako dat. typ float
			for (int h=0; h < count; h++){			
				
				for (int g=0; g<count; g++){
					matrix[3*h+g]=Float.valueOf(jTable1.getValueAt(h, g).toString());
					
				}
			}
			try {
				//vytvoreni kernelovske matice urcene pro vytvoreni konvolucniho filtru
				Kernel kernel = new Kernel(count,count,matrix);
				//vyvtovreni instance tridy UserDefined a provedeni filtrovani
				UserDefined user= new UserDefined(kernel);	
				BufferedImage buf = user.filter(src);
				src = buf;
				//zobrazeni vysledneho obrazu
				ims.setImage((Image)src); 
			} catch (Exception e2){
				this.dialog("Filter does not work properly!");
			}
			
			//prekresleni
			context.getLayerViewPanel().repaint();
		}
		}
	

   
    public void saveImage(BufferedImage image)
    {
    	   	
    	try {
    		
    		//objekt tridy JFileChooser predstavuje dialogove okno
    		JFileChooser  chooser= new JFileChooser();
    		//zruseni predchozich souborovych filtru pro objekt chooser
    		chooser.resetChoosableFileFilters();
    		
    		//***** nastaveni a pridani novych souborovych filtru *****
    		ExampleFileFilter filtJPG = new ExampleFileFilter ("jpg", "JPEG Compressed Image Files");   
    		ExampleFileFilter filtPNG = new ExampleFileFilter ("png", "Portable Network Graphics");
    		ExampleFileFilter filtTIF = new ExampleFileFilter ("tif", "Tagged Image File format");
    		ExampleFileFilter filtGIF = new ExampleFileFilter ("gif", "Graphic Interchange Format");
    		ExampleFileFilter filtBMP = new ExampleFileFilter ("bmp", "Bitmap Image File");
    		chooser.addChoosableFileFilter(filtJPG);   
    		chooser.addChoosableFileFilter(filtPNG); 
    		chooser.addChoosableFileFilter(filtTIF);
    		chooser.addChoosableFileFilter(filtGIF);
    		chooser.addChoosableFileFilter(filtBMP);
    		//***********************************************************
    		
    		//nastaveni typu dialogoveho okna SAVE a zobrazeni v aktualnim okne
    		int returnVal = chooser.showSaveDialog(this);
    		
    		//pomoci vybraneho filtru je ulozen do promenne suffix pozadovany typ souboru 
    		String filt=chooser.getFileFilter().getDescription();
    		String suffix= filt.substring(filt.length()-4, filt.length()-1).toLowerCase();
    		
    		//vytvoreni pozadovaneho souboru dle vybraneho typu souboru do adresare 
    		File outut=new File(chooser.getCurrentDirectory().getPath()+'\\' + chooser.getSelectedFile().getName()+"."+suffix);
    		
    		//ulozeni bufferedimage do souboru outut
    		ImageIO.write(src, suffix, outut);
    		
    		
    	}catch (Exception e2){
    		dialog("The process was not successful");
    	}
    	
    }  
    public void setTable(int count){
    	//metoda pro nastaveni rozmeru matice a vsech jejich hodnot na nulu
    	
    	jTable1.setModel(new DefaultTableModel(count, count));
    		
		for (int h=0; h < count; h++){	
			
			for (int g=0; g<count; g++){
				jTable1.setValueAt(0,g,h);
			}
		}
		
    }
}
